package com.logicbig.example;

import static com.logicbig.example.RegexUtil.test;

public class RegexExamples {

    public static void main(String[] args) {

        //The plus greedy quantifier +
        test("a+", "");
        test(".+", "");
        test("a+", "ababaaaab");
        test("a+b", "bbbaaab");
        test(".+x", "abc x");
        test("(xyz)+", "zz xyz abc xyzxyz xy");
        test("(a|b)+", "aaaa bb cabc");
        test("((abc)|(xyz))+",
                "abc xyz zyxabc abcxyz xyzabc");
        test("[0-9]+", "9823 340");
        test("([0-9]|\\W)+", "9823 340");
        test(".+ten", "AtenAAAAAten");
        test("A.+ten", "xtenAAAAAten");
        test("ten+", "tenAAAAAten");
        //asterisk greedy quantifier *

        test(".*", "");
        test(".*", "Anything matches");
        test(".*x", "Sandbox");
        test("x.*", "xenon");
        test(".*test", "testyyxxtest");
        test("\\W.*", "this is a sentence");
        test("t*", "yx");
        test(".*abc", "zzzzabcyyy");
        test("s*", "ssssssst");
        test("l.*c", "appeal to logic");
        test("\\bl.*c\\b", "appeal to logic");

        //The question mark greedy quantifier ?
        test(".?", "");
        test(".?", "aaaa");
        test("a?", "aab");
        test(".?", "red car");
        test("(red)?", "red car");
        test("([0-9][0-9][A-Z])?", "89C34D555");

        //The Curly brackets greedy quantifiers {}
        test("x{2}", "xx xxx");
        test("x{2,}", "xx xxx, xxxx");
        test("x{1,3}", "xx xxx, xxxx");
        test("x{0,2}", "xx xxx, xxxx");
        test("(li){2,}", "lilies milliliter");
        test("\\b[a-z]{3,3}\\b", "A fly has big eyes");
        test("[a-z][0-9]{2,3}", "aa29 a3333 3d43");
        test("([a-z][0-9]){2,2}", "aa29 a3d4a3");
    }
}